<?php

/**
 * Class for creating PostgreSQL queries.
 * Fully supports PostgreSQL as of version 7.1.
 *
 * Important:
 * ==========
 * As of version 7.1 PostgreSQL supports outer joins
 * (also called left joins). ATK makes use of outer joins
 * for relationships. This means you can only make use
 * of the PostgreSQL support if you use version 7.1 or
 * higher of the PostgreSQL database server. Using older
 * versions is not supported, but might work as long you
 * don't make use of relations that allow null values.
 *
 * @author Peter C. Verhage (peter@ibuildings.nl)
 * @version $Revision: 1.2 $
 *
 * $Id: class.atkpgsqlquery.inc,v 1.2 2001/04/19 17:30:29 peter Exp $
 * $Log: class.atkpgsqlquery.inc,v $
 * Revision 1.2  2001/04/19 17:30:29  peter
 * PostgreSQL as of version 7.1 supports outer joins (left joins).
 * This means PostgreSQL can now be fully supported (> 7.1) by ATK.
 *
 */
if (!defined("CLASS_ATKPGSQLQUERY_INC"))
{
  define("CLASS_ATKPGSQLQUERY_INC", 1);

  class atkpgsqlquery extends atkquery
  {
    // We don't have to do anything that differs
    // from the basic query class at the moment. 
  }
} /* endif CLASS_ATKPGSQLQUERY_INC; */

?>